<?php
class ControllerOutrosRedirecionamento301 extends Controller {

  private $error = array();

	public function index() {
		$language = $this->language->load('outros/redirecionamento301');

    $this->data = array_merge($this->data, $language);

		$this->document->setTitle($this->language->get('heading_title'));
		$this->load->model('outros/redirecionamento301');

    $this->load->model('setting/setting');




    $this->getList();
  }

  public function getform() {

    $this->data['button_save'] = $this->language->get('button_save');
    $this->data['button_voltar'] = $this->language->get('button_voltar');

    if (isset($this->error['warning'])) {
      $this->data['error_warning'] = $this->error['warning'];
    } else {
      $this->data['error_warning'] = '';
    }

    if (isset($this->error['error_link_origem'])) {
			$this->data['error_link_origem'] = $this->error['error_link_origem'];
		} else {
			$this->data['error_link_origem'] = '';
		}

    if (isset($this->error['error_link_destino'])) {
			$this->data['error_link_destino'] = $this->error['error_link_destino'];
		} else {
			$this->data['error_link_destino'] = '';
		}

    $this->data['token'] = $this->session->data['token'];

  	$this->data['breadcrumbs'] = array();

   	$this->data['breadcrumbs'][] = array(
    	'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
    	'separator' => false
   	);

   	$this->data['breadcrumbs'][] = array(
    	'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('outros/redirecionamento301', 'token=' . $this->session->data['token'] . '&type=' . $this->request->get['type'], 'SSL'),
    	'separator' => ' :: '
   	);

    $this->data['voltar'] = $this->url->link('outros/redirecionamento301', 'token=' . $this->session->data['token'] . '&type=' . Type_TitleModules::Tp_Outros, 'SSL');

    if (isset($this->session->data['success'])) {
			$this->data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$this->data['success'] = '';
		}

    $this->template = 'outros/redirecionamento301.tpl';
		$this->children = array(
			'common/header',
			'common/footer'
		);

		$this->response->setOutput($this->render('outros/redirecionamento301'));

	}

  public function getList() {

    if (isset($this->error['warning'])) {
      $this->data['error_warning'] = $this->error['warning'];
    } else {
      $this->data['error_warning'] = '';
    }

    $this->data['token'] = $this->session->data['token'];

    $this->data['insert'] = $this->url->link('outros/redirecionamento301/insert', 'token=' . $this->session->data['token'].'&type='.Type_TitleModules::Tp_Outros, 'SSL');

    if ($this->request->server['REQUEST_METHOD'] == 'POST') {
        $this->model_setting_setting->editSetting('redirecionamento301', $this->request->post);
        $this->session->data['success'] = $this->language->get('text_save_success');
        $this->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'].'&type='.Type_TitleModules::Tp_Outros, 'SSL'));
    }

    if (isset($this->session->data['success'])) {
			$this->data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$this->data['success'] = '';
		}


    if (isset($this->request->post['redirecionamento301_status'])) {
			$this->data['redirecionamento301_status'] = $this->request->post['redirecionamento301_status'];
		} else {
			$this->data['redirecionamento301_status'] = $this->config->get('redirecionamento301_status');
        }

    $this->data['link_back'] = $this->url->linkAnchor(
        'extension/module',
        'token=' . $this->session->data['token'],
        'tab-info=' . $this->request->get['type'],
        'SSL'
    );

    $this->data['cancel'] = $this->data['link_back'];

  	$this->data['breadcrumbs'] = array();

   	$this->data['breadcrumbs'][] = array(
    	'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
    	'separator' => false
    );

    $this->data['breadcrumbs'][] = array(
        'text' => $this->language->get('text_module'),
        'href' => $this->data['link_back']
    );

   	$this->data['breadcrumbs'][] = array(
    	'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('outros/redirecionamento301', 'token=' . $this->session->data['token'] . '&type=' . $this->request->get['type'], 'SSL'),
    	'separator' => ' :: '
   	);

    if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}
    $url = '';
    if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

    $data = array(
			'start' => ($page - 1) * $this->config->get('config_admin_limit'),
			'limit' => $this->config->get('config_admin_limit')
		);

    $this->load->helper('ftr_geral');

    foreach(Type_Status::getEnumList() as $key  => $value) {
      $this->data['status'][] = array(
        'key'      => $key,
        'selected' => ftr_geral::isSelected($key, $this->data['redirecionamento301_status']),
        'value'    => $value
      );
    }



    $results = $this->model_outros_redirecionamento301->getRedirecionamentos($data);


    $language = $this->language->load('outros/redirecionamento301');
    $this->data = array_merge($this->data, $language);

    foreach ($results as $result) {
      $this->data['redirecionamentos'][] = array(
        'link_origem'  => $result['link_origem'],
        'link_destino' => $result['link_destino'],
        'url_delete'   => $this->url->link('outros/redirecionamento301/delete', 'token=' . $this->session->data['token'] . '&redirect_id=' . $result['id'].'&type='.Type_TitleModules::Tp_Outros , 'SSL'),
        'url_edit'     => $this->url->link('outros/redirecionamento301/update', 'token=' . $this->session->data['token'] . '&redirect_id=' . $result['id'].'&type='.Type_TitleModules::Tp_Outros , 'SSL')
      );
    }
    $totalRedirecionamentos = $this->model_outros_redirecionamento301->getTotalRedirecionamentos();

    $pagination = new Pagination();
		$pagination->total = $totalRedirecionamentos;
		$pagination->page = $page;
		$pagination->limit =  $this->config->get('config_admin_limit');
		$pagination->text = $this->language->get('text_pagination');
		$pagination->url = $this->url->link('outros/redirecionamento301', 'token=' . $this->session->data['token'] . $url . '&page={page}', 'SSL');

		$this->data['pagination'] = $pagination->render();

    $this->template = 'outros/redirecionamento301List.tpl';
		$this->children = array(
			'common/header',
			'common/footer'
		);

		$this->response->setOutput($this->render('outros/redirecionamento301List'));

  }

  public function insert() {
    $language = $this->language->load('outros/redirecionamento301');
    $this->data = array_merge($this->data, $language);
		$this->document->setTitle($this->language->get('heading_title'));
		$this->load->model('outros/redirecionamento301');

    $this->data['action'] = $this->url->link('outros/redirecionamento301/insert', 'token=' . $this->session->data['token'] . '&type=' . $this->request->get['type'], 'SSL');

    if (isset($this->request->post['link_origem'])) {
			$this->data['link_origem'] = $this->request->post['link_origem'];
		} else {
			$this->data['link_origem'] = '';
		}

    if (isset($this->request->post['link_destino'])) {
			$this->data['link_destino'] = $this->request->post['link_destino'];
		} else {
			$this->data['link_destino'] = '';
		}

    if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {
			$this->model_outros_redirecionamento301->addRedirecionamento($this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

      $this->data['link_origem'] = '';
      $this->data['link_destino'] = '';

			$this->redirect($this->url->link('outros/redirecionamento301', 'token=' . $this->session->data['token'].'&type='.Type_TitleModules::Tp_Outros, 'SSL'));
	  }

    $this->getForm();

  }

  public function update() {
    $language = $this->language->load('outros/redirecionamento301');
    $this->data = array_merge($this->data, $language);
		$this->document->setTitle($this->language->get('heading_title'));
		$this->load->model('outros/redirecionamento301');



    if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {

			$this->model_outros_redirecionamento301->updateRedirecionamento($this->request->get['redirect_id'], $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->redirect($this->url->link('outros/redirecionamento301', 'token=' . $this->session->data['token'].'&type='.Type_TitleModules::Tp_Outros, 'SSL'));
	  }

    $this->data['action'] = $this->url->link('outros/redirecionamento301/update', 'token=' . $this->session->data['token']. '&type=' . $this->request->get['type'] . '&redirect_id=' . $this->request->get['redirect_id'], 'SSL');

    $redirecionamento =  $this->model_outros_redirecionamento301->getRedirecionamento($this->request->get['redirect_id']);


    if (isset($redirecionamento['link_origem'])) {
			$this->data['link_origem'] = $redirecionamento['link_origem'];
		} else {
			$this->data['link_origem'] = '';
		}

    if (isset($redirecionamento['link_destino'])) {
			$this->data['link_destino'] = $redirecionamento['link_destino'];
		} else {
			$this->data['link_destino'] = '';
		}

    if (isset($redirecionamento['id'])) {
			$this->data['redirect_id'] = $redirecionamento['id'];
		} else {
			$this->data['redirect_id'] = '';
		}




    $this->getForm();
  }

  public function delete() {
		$this->load->model('outros/redirecionamento301');

    $language = $this->language->load('outros/redirecionamento301');
    $this->data = array_merge($this->data, $language);

    if (isset($this->request->get['redirect_id'])){
		  $this->model_outros_redirecionamento301->deleteRedirecionamento($this->request->get['redirect_id']);

      $this->session->data['success'] = $this->language->get('text_delete_success');
    }

    $url_list = str_replace("&amp;","&",$this->url->link('outros/redirecionamento301', 'token=' . $this->session->data['token'].'&type='.Type_TitleModules::Tp_Outros, 'SSL'));

    header('Location: ' . $url_list);


  }

  public function validateForm() {


    if($this->request->post['link_origem'] == ""){
        $this->error['error_link_origem'] = $this->language->get('error_link_origem');
    }

    if($this->request->post['link_destino'] == ""){
        $this->error['error_link_destino'] = $this->language->get('error_link_destino');
    }

    if (!$this->error) {
			return true;
		} else {
			return false;
		}
  }

}
